/*
 *  conversationtree.hpp
 *  Template
 *
 *  Created by increpare on 04/04/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

/*
 
 three stories
 
STRUCTUREDONE 1: weather
 2: investigation
 3: trauma
 
DONE levenstehn distance
DONE string -> vector of words
abandoned make choice of string elements <|> notation (After structures made)
DONE text-wrapping
 print available options
DONE select options
 remove options/insert new ones into list
 square selection
 DONE text replacement/reconstitution
 DONE maxtolerance
 DONE minlevenshtein
 select stories at start
 esc to restart form menu
 tidy up title screen
 */

/*
 6 weathers
 6 investigations
 6 traumas
 
 
 cancer
 */

#include <string>
#include <list>
using namespace std;

#include "leven.hpp"


class Conv 
{
public:
	string task;
	string res;
	list<Conv> consequents;
	
	Conv(const string& t, const string& r, const list<Conv> c)
	{
		task=t;
		res=r;
		consequents=c;
	};
	
	Conv(const Conv& cv)
	{
		task=cv.task;
		res=cv.res;
		consequents=cv.consequents;
	};
	
	Conv& operator=(const Conv& rhs)
	{
		if (this == &rhs)              // assumes op== exists
			return *this;
		
		task=rhs.task;
		res=rhs.res;
		consequents=rhs.consequents;
		return *this;
	};
	
	bool operator==( const Conv & c) const
	{
		return (task==c.task);
	};
	
	bool operator!=( const Conv & c) const
	{
		return (task!=c.task);
	};
	
};

vector<string> parsestring(const string& s)
{
	vector<string> a;
	string w;
	
	for (unsigned int i=0;i<s.size();i++)
	{
		if (isalpha(s[i]))
		{
			w.push_back(tolower(s[i]));
		}
		else
		{
			if (w.length()>0)
			{
				a.push_back(w);
			}
			string x;
			x.push_back(s[i]);
			a.push_back(x);
			w="";
		}
	}
	
	return a;
}

string reconstitute(const vector<string>& traumawords)
{
	string s;
	for (unsigned int i=0;i<traumawords.size();i++)
	{
		s+=traumawords[i];
	}
	
	return s;
}

bool isword(const string& s)
{
	return isalpha(s[0]);
}


